/********************************** (C) COPYRIGHT *******************************
* File Name          : MAIN.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/07/10
* Description        : CH569ʵUSBHSPI˫,
*                      ģCH372/CH375豸(USB3.0)ʵHSPIUSB˵˫͸
*					   1USB˵
*                        (1)˵1˵,˵С=1024ݴ˵,ݴӿHSPI
*                        (2)˵2˵,˵С=1024Сݴ˵,ݴӿUART1
*					   2˵㣬˵1ó4ͻ
*					   3˵1ϴСΪ48K´Ϊ32K
*					   4HSPIͻСΪ4KÿͻΪ4
*					   5HSPI+USBϴٶȲ300M/S,USB´+HSPIٶȲ230M/S
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.h"                                                               /* ͷļ */


/******************************************************************************/
/*  */
UINT8V  USB_Stop_UpFlag = 0x00;                                                 /* USBֹͣϴ־ */

/* Ϊر */
UINT32V Dbg_Idle_TimeCount = 0x00;
UINT64V Dbg_HSPI_Tx_TLen = 0x00;
UINT64V Dbg_HSPI_Rx_TLen = 0x00;
UINT64V Dbg_USB_Up_TLen = 0x00;
UINT64V Dbg_USB_Down_TLen = 0x00;


/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    UINT32  addr,i,j;
    UINT32V remanlen;
    UINT32V len;
    UINT32V packnum;
    UINT32V packlen;
    UINT32V offset;

    /*****************************ϵͳسʼ*******************************/
    SystemInit( FREQ_SYS );
	Delay_Init( FREQ_SYS );

    /*****************************ģųʼ**************************/
	UART1_Init( DEF_UART1_BAUDRATE );
	HSPI_GPIO_Init( );                                                      	/* HSPIӿGPIOʼ */
    GPIO_Init( );                                                           	/* ӲGPIOʼ */
	DUG_PRINTF("CH569_BULK_UVC@120MHZ_V1.%d\n",(UINT16)DEF_PROG_VERSION - 0x01 );
    DUG_PRINTF("Edit Date and Time is: "__DATE__"  " __TIME__"\n");

    /*****************************USB豸سʼ **************************/
    DUG_PRINTF("USB Init\n");
    R32_USB_CONTROL = 0;
    PFIC_SetPriority( USBSS_IRQn, 0x80 );
    PFIC_SetPriority( LINK_IRQn, 0x80 );
    PFIC_SetPriority( HSPI_IRQn, 0x00 );

	PFIC_EnableIRQ( USBSS_IRQn );
	PFIC_EnableIRQ( LINK_IRQn );
	PFIC_EnableIRQ( TMR0_IRQn );
	R8_TMR0_INTER_EN = 1;
	TMR0_TimerInit( 67000000 );   												/* Լ0.5 */
	USB30D_init( ENABLE );          										    /* USB3.0ʼ,ʼ֮ǰȷUSB3.0жʹ */

	PFIC_FastINT0CFG( USBSS_IRQn, (UINT32)USBSS_IRQHandler );					/* ÿжģʽ */

    /*****************************HSPI豸سʼ **************************/
    DUG_PRINTF("HSPI Init\n");
    DUG_PRINTF("HSPI Slaver Mode\n");
    HSPI_Init( );     //Ϊӻ          /* HSPIӿڳʼ */

//    while(!(PIN_HCTS_RD( ) == 0x00));   //ȴӻʼ



    /*****************************ʱسʼ **************************/
    Timer1_Init( 240000 );                                                      /* ʱ1ʼ(ʱ2mS) */

    /*******************************************************************/
    DUG_PRINTF("Main\n");

    USB30_IN_Set(ENDP_1, ENABLE, ACK, NUMP_4, 1024); //ܹ4

    /* ӻHRTS֪ͨ16K */
    Delay_mS( 1000 );
    HSPI_Rx_Notice_Status = 0x01;

    HSPI_Rx_Data_RemainLen = 0x00;
    USB_Stop_UpFlag = 0x00;

#if( DEF_FUN_DEBUG_EN == 0x01 )
    Dbg_Idle_TimeCount = 0x00;
    Dbg_HSPI_Tx_TLen = 0x00;
    Dbg_HSPI_Rx_TLen = 0x00;
    Dbg_USB_Up_TLen = 0x00;
    Dbg_USB_Down_TLen = 0x00;
#endif

    while( 1 )
    {
#if 1
/**********************************FPGA->PC****************************************************************************/
        /* HSPIͨUSB˵ϴ */
        if( Endp1_Up_Status == 0x00 )
        {
            /* жǷҪϴ */
            R8_HSPI_INT_EN = 0x00;
            R8_HSPI_INT_EN = 0x00;
            remanlen = HSPI_Rx_Data_RemainLen;
//            printf("HSPI_Rx_Data_RemainLen:%d\n",HSPI_Rx_Data_RemainLen);
            R8_HSPI_INT_EN = HSPI_Int_En_Save;
            if( remanlen )
            {
                /* 㱾ϴȼ */
                offset = ( DEF_HPSI_RX_DMA_ADDR_MAX - HSPI_Rx_Data_DealAddr );
                if( remanlen >= ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
                {
                    /* жϻƫǷ㹻෢͵ĩβ */
                    if( offset >= ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
                    {
                        Endp1_Up_LastPackLen = ( DEF_ENDP1_IN_BURST_LEVEL * 1024 );
                        Endp1_Up_LastPackNum = DEF_ENDP1_IN_BURST_LEVEL;
                        len = 1024;
                    }
                    else
                    {
                        Endp1_Up_LastPackLen = offset;
                        Endp1_Up_LastPackNum = Endp1_Up_LastPackLen / 1024;
                        len = Endp1_Up_LastPackLen % 1024;
                        if( len )
                        {
                            Endp1_Up_LastPackNum++;
                        }
                        else if( len == 0 )
                        {
                            len = 1024;
                        }
                    }
                }
                else
                {
                    /* жϻƫǷ㹻෢͵ĩβ */
                    if( offset >= remanlen )
                    {
                        Endp1_Up_LastPackLen = remanlen;
                    }
                    else
                    {
                        Endp1_Up_LastPackLen = offset;
                    }
                    Endp1_Up_LastPackNum = Endp1_Up_LastPackLen / 1024;
                    len = Endp1_Up_LastPackLen % 1024;
                    if( len )
                    {
                        Endp1_Up_LastPackNum++;
                    }
                    else if( len == 0 )
                    {
                        len = 1024;
                    }
                }

                /* USBϴ */
                USB30_IN_Set( ENDP_1, ENABLE , ACK , Endp1_Up_LastPackNum, len );
                USB30_Send_ERDY( ENDP_1 | IN , Endp1_Up_LastPackNum );
                /* ö˵1ϴ״̬ */
                Endp1_Up_Status = 0x01;
            }
        }
/**************************************************************************************************************/
        /* жǷҪ֪ͨHSPI */
        R8_HSPI_INT_EN = 0x00;
        R8_HSPI_INT_EN = 0x00;
        R8_HSPI_INT_EN = 0x00;
        remanlen = HSPI_Rx_Data_RemainLen;
        R8_HSPI_INT_EN = HSPI_Int_En_Save;
        if( remanlen <= ( DEF_ENDP1_TX_BUF_LEN_BULK - DEF_HSPI_BULK_BPACK_LEN ) )
        {
            /* ӻHRTS֪ͨ16K */
            if( HSPI_Rx_Notice_Status == 0x01 )
            {
                HSPI_Rx_Notice_Status = 0x00;
                if( USB_Stop_UpFlag == 0x00 )
                {
                    PIN_HRTS_LOW( );  //HRTS͵ƽ
                }
            }
        }
/*****************************PC->FPGA*********************************************************************************/
        /* USB˵´ͨHSPIӿڷ */
        R8_HSPI_INT_EN = 0x00;
        R8_HSPI_INT_EN = 0x00;
        R8_HSPI_INT_EN = 0x00;
        if( ( HSPI_Tx_Status == 0x00 ) && ( PIN_HCTS_RD( ) == 0x00 ) )  //HSPI_Tx_StatusΪ1ͻûн   Ϊ0ǰûз Զ˽ŵ͵ƽԽ
        {
            HSPI_Tx_Data_Deal( );
        }
        R8_HSPI_INT_EN = HSPI_Int_En_Save;
/**************************************************************************************************************/
        /* жUSB˵´Ƿͣ */
        if( Endp1_Down_Status )
        {
            /* жϵǰǷǿͣ,ǻͣ */
            R8_HSPI_INT_EN = 0x00;
            R8_HSPI_INT_EN = 0x00;
            R8_HSPI_INT_EN = 0x00;
            remanlen = HSPI_Tx_Data_RemainLen;
            R8_HSPI_INT_EN = HSPI_Int_En_Save;
            if( USB_Down_StopFlag )
            {
                /* ȫݷ֮,ʹUSB´ */
                if( remanlen == 0x00 )
                {
                    USB_Down_StopFlag = 0x00;
                    Endp1_Down_Status = 0x00;

                    /* HSPIͻUSB˵ջָͷ */
                    HSPI_Tx_Data_LoadAddr = DEF_HPSI_DMA_TX_ADDR0;
                    HSPI_Tx_Data_DealAddr = DEF_HPSI_DMA_TX_ADDR0;
                    USBSS->UEP1_RX_DMA = HSPI_Tx_Data_LoadAddr;

                    /* ֪ͨ´N */
                    packnum = DEF_ENDP1_IN_BURST_LEVEL;
                    USB30_OUT_Set( ENDP_1, ACK, packnum );
                    USB30_Send_ERDY( ENDP_1 | OUT , packnum );
                }
            }
            else
            {
                /* 㹻ռ,ʹUSB´ */
                if( remanlen <= ( DEF_ENDP1_RX_BUF_LEN - ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) ) )
                {
                    Endp1_Down_Status = 0x00;

                    /* жϻƫǷ㹻,Ҫ */
                    packnum = DEF_ENDP1_IN_BURST_LEVEL;
                    packlen = ( DEF_HPSI_TX_DMA_ADDR_MAX - HSPI_Tx_Data_LoadAddr );
                    if( packlen < ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
                    {
                        packnum = packlen / 1024;
                    }

                    /* ֪ͨ´N */
                    USB30_OUT_Set( ENDP_1, ACK, packnum );
                    USB30_Send_ERDY( ENDP_1 | OUT , packnum );
                }
            }
        }
#endif
    }
}
