/********************************** (C) COPYRIGHT *******************************
* File Name          : CH56x_usb30.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/31
* Description 		 :
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "CH56x_common.h"
#include "CH56xUSB30_LIB.H"
#include "CH56x_usb20.h"
#include "CH56x_usb30.h"
#include "USB30_DESC_BULK.h"
/*
 * ΪUSB3.0 deviceʹ
 * 1Ŷ˵ͻ4ݺȻ1Ŷ˵ȡ4
 * 2Ŷ˵´ ͬʱҲ2Ŷ˵ȡ
 * */
/* Global define */
/* Global Variable */
UINT32V SetupLen = 0;
UINT8V  SetupReqCode = 0;
PUINT8V pDescr;
UINT8V  USB30_Link_Status = 0x00;
UINT8V  USB30_Tx_Lmp_Port = 0x00;
UINT8V  USB30_Config = 0x00;
UINT32V USB30_EP0_T_SEQ = 0x00;

UINT32V Endp1_Up_LastPackNum = 0x00;                                            /* ˵1ϴİ */
UINT32V Endp1_Up_LastPackLen = 0x00;                                            /* ˵1ϴİ */
UINT32V Endp1_Up_Status = 0x00;                                                 /* ˵1ϴ״̬: 0: ; 1: ϴ; */
UINT32V Endp1_Down_LastPackNum = 0x00;                                          /* ˵1´İ */
UINT32V Endp1_Down_LastPackLen = 0x00;                                          /* ˵1´İ */
UINT32V Endp1_Down_Status = 0x00;                                               /* ˵1´״̬: 0: ´; 1: ֹͣ´; */
UINT32V Endp1_Down_IdleCount = 0x00;                                            /* ˵1´мʱ; */

UINT8V  USB_Down_StopFlag = 0x00;                                               /* USB´ͣ־(USBյ,ȴHSPIټ´) */
UINT8V  HSPI_RX_StopFlag = 0x00;                                                /* HSPIͣ־(HSPIյ,ȴUSBϴټ) */
static  UINT32V remanlen;

__attribute__((aligned(16))) UINT8 endp0RTbuff[512] __attribute__((section(".DMADATA")));  //˵0շ
__attribute__((aligned(16))) UINT8 endp1RTbuff[4096] __attribute__((section(".DMADATA"))); //˵1շ
__attribute__((aligned(16))) UINT8 endp2RTbuff[4096] __attribute__((section(".DMADATA"))); //˵2շ
__attribute__((aligned(16))) UINT8 endp3RTbuff[4096] __attribute__((section(".DMADATA"))); //˵3շ
__attribute__((aligned(16))) UINT8 endp4RTbuff[4096] __attribute__((section(".DMADATA"))); //˵4շ
__attribute__((aligned(16))) UINT8 endp5RTbuff[4096] __attribute__((section(".DMADATA"))); //˵5շ
__attribute__((aligned(16))) UINT8 endp6RTbuff[4096] __attribute__((section(".DMADATA"))); //˵6շ
__attribute__((aligned(16))) UINT8 endp7RTbuff[4096] __attribute__((section(".DMADATA"))); //˵7շ


/*******************************************************************************
 * @fn      USB30_BUS_RESET
 *
 * @brief   USB3.0߸λѡλʽֻλUSBķʽ⣬ԲøλƬķʽ
 *
 * @return   None
 */
void USB30_BUS_RESET()
{
    USB30D_init(DISABLE); //USB3.0ʼ
    mDelaymS(20);
    USB30D_init(ENABLE); //USB3.0ʼ
}

/*******************************************************************************
 * @fn      USB30D_init
 *
 * @brief   USB3.0豸ʼ
 *
 * @return   None
 */
void USB30D_init(FunctionalState sta)
{
    UINT16 i, s;
    if(sta)
    {
        s = USB30_Device_Init( );
        if(s)
        {
            DUG_PRINTF("Init err\n");
            while(1)
                ;
        }
        USBSS->UEP_CFG = EP0_R_EN | EP0_T_EN | EP1_R_EN | EP1_T_EN | EP2_R_EN | EP2_T_EN | EP3_R_EN | EP3_T_EN | EP4_R_EN | EP4_T_EN | EP5_R_EN | EP5_T_EN | EP6_R_EN | EP6_T_EN | EP7_R_EN | EP7_T_EN; // set end point rx/tx enable

        USBSS->UEP0_DMA = (UINT32)(UINT8 *)endp0RTbuff;
        USBSS->UEP1_TX_DMA = (UINT32)(UINT8 *)endp1RTbuff;
        USBSS->UEP2_TX_DMA = (UINT32)(UINT8 *)endp2RTbuff;
        USBSS->UEP3_TX_DMA = (UINT32)(UINT8 *)endp3RTbuff;
        USBSS->UEP4_TX_DMA = (UINT32)(UINT8 *)endp4RTbuff;
        USBSS->UEP5_TX_DMA = (UINT32)(UINT8 *)endp5RTbuff;
        USBSS->UEP6_TX_DMA = (UINT32)(UINT8 *)endp6RTbuff;
        USBSS->UEP7_TX_DMA = (UINT32)(UINT8 *)endp7RTbuff;

        USBSS->UEP1_RX_DMA = (UINT32)(UINT8 *)endp1RTbuff;
        USBSS->UEP2_RX_DMA = (UINT32)(UINT8 *)endp2RTbuff;
        USBSS->UEP3_RX_DMA = (UINT32)(UINT8 *)endp3RTbuff;
        USBSS->UEP4_RX_DMA = (UINT32)(UINT8 *)endp4RTbuff;
        USBSS->UEP5_RX_DMA = (UINT32)(UINT8 *)endp5RTbuff;
        USBSS->UEP6_RX_DMA = (UINT32)(UINT8 *)endp6RTbuff;
        USBSS->UEP7_RX_DMA = (UINT32)(UINT8 *)endp7RTbuff;

        USB30_OUT_Set(ENDP_1, ACK, DEF_ENDP1_OUT_BURST_LEVEL); // endpoint1 receive setting
        USB30_OUT_Set(ENDP_2, ACK, DEF_ENDP2_OUT_BURST_LEVEL);
        USB30_OUT_Set(ENDP_3, ACK, DEF_ENDP3_OUT_BURST_LEVEL);
        USB30_OUT_Set(ENDP_4, ACK, DEF_ENDP4_OUT_BURST_LEVEL);
        USB30_OUT_Set(ENDP_5, ACK, DEF_ENDP5_OUT_BURST_LEVEL);
        USB30_OUT_Set(ENDP_6, ACK, DEF_ENDP6_OUT_BURST_LEVEL);
        USB30_OUT_Set(ENDP_7, ACK, DEF_ENDP7_OUT_BURST_LEVEL);

        USB30_IN_Set(ENDP_2, ENABLE, ACK, DEF_ENDP2_IN_BURST_LEVEL, 1024); // endpoint2 send setting
    }
    else
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_CFG = PIPE_RESET | LFPS_RX_PD;
        USBSS->LINK_CTRL = GO_DISABLED | POWER_MODE_3;
        USBSS->LINK_INT_CTRL = 0;
        USBSS->USB_CONTROL = USB_FORCE_RST | USB_ALL_CLR;
    }
}

/*******************************************************************************
 * @fn      USB30_NonStandardReq
 *
 * @brief   USB3.0Ǳ׼
 *
 * @return   
 */
UINT16 USB30_NonStandardReq()
{
    UINT8 endp_dir;

    SetupReqCode = UsbSetupBuf->bRequest;
    SetupLen = UsbSetupBuf->wLength;
    endp_dir = UsbSetupBuf->bRequestType & 0x80;
    UINT16 len = 0;
#if 0
    DUG_PRINTF("NS:%02x %02x %02x %02x %02x %02x %02x %02x\n", endp0RTbuff[0], endp0RTbuff[1],
            endp0RTbuff[2], endp0RTbuff[3], endp0RTbuff[4], endp0RTbuff[5],
            endp0RTbuff[6], endp0RTbuff[7]);
#endif
    switch(SetupReqCode)
    {
#if 0
        case 0x01:
            break;
#endif
        case 0x02: //û
            switch(UsbSetupBuf->wIndex.bw.bb1)
            {
                case 0x05:
                    if(SetupLen > SIZE_PropertyHeader)
                        SetupLen = SIZE_PropertyHeader;
                    pDescr = (PUINT8)PropertyHeader;
                    break;
                default:
                    SetupReqCode = INVALID_REQ_CODE;
                    return USB_DESCR_UNSUPPORTED;
                    break;
            }
            break;
        default:
            DUG_PRINTF("stall\n");
            SetupReqCode = INVALID_REQ_CODE;
            return USB_DESCR_UNSUPPORTED;
            break;
    }
    len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen; // δ䳤
    if(endp_dir)
    {
        memcpy(endp0RTbuff, (UINT8 *)pDescr, len); // device  /* ϴ */
        pDescr += len;
    }
    SetupLen -= len;
    return len;
}

/*******************************************************************************
 * @fn      USB30_StandardReq
 *
 * @brief   USB3.0׼
 *
 * @return   
 */
UINT16 USB30_StandardReq()
{
    SetupReqCode = UsbSetupBuf->bRequest;
    SetupLen = UsbSetupBuf->wLength;
    UINT16 len = 0;
#if 0
    DUG_PRINTF("S:%02x %02x %02x %02x %02x %02x %02x %02x\n", endp0RTbuff[0], endp0RTbuff[1],
            endp0RTbuff[2], endp0RTbuff[3], endp0RTbuff[4], endp0RTbuff[5],
            endp0RTbuff[6], endp0RTbuff[7]);
#endif
    switch(SetupReqCode)
    {
        case USB_GET_DESCRIPTOR:
            switch(UsbSetupBuf->wValue.bw.bb0)
            {
                case USB_DESCR_TYP_DEVICE:
                    if(SetupLen > SIZE_DEVICE_DESC)
                        SetupLen = SIZE_DEVICE_DESC;
                    pDescr = (PUINT8)SS_DeviceDescriptor;
                    break;
                case USB_DESCR_TYP_CONFIG:
                    if(SetupLen > SIZE_CONFIG_DESC)
                        SetupLen = SIZE_CONFIG_DESC;
                    pDescr = (PUINT8)SS_ConfigDescriptor;
                    break;
                case USB_DESCR_TYP_BOS:
                    if(SetupLen > SIZE_BOS_DESC)
                        SetupLen = SIZE_BOS_DESC;
                    pDescr = (PUINT8)BOSDescriptor;
                    break;
                case USB_DESCR_TYP_STRING:
                    switch(UsbSetupBuf->wValue.bw.bb1)
                    {
                        case USB_DESCR_LANGID_STRING:
                            if(SetupLen > SIZE_STRING_LANGID)
                                SetupLen = SIZE_STRING_LANGID;
                            pDescr = (PUINT8)StringLangID;
                            break;
                        case USB_DESCR_VENDOR_STRING:
                            if(SetupLen > SIZE_STRING_VENDOR)
                                SetupLen = SIZE_STRING_VENDOR;
                            pDescr = (PUINT8)StringVendor;
                            break;
                        case USB_DESCR_PRODUCT_STRING:
                            if(SetupLen > SIZE_STRING_PRODUCT)
                                SetupLen = SIZE_STRING_PRODUCT;
                            pDescr = (PUINT8)StringProduct;
                            break;
                        case USB_DESCR_SERIAL_STRING:
                            if(SetupLen > SIZE_STRING_SERIAL)
                                SetupLen = SIZE_STRING_SERIAL;
                            pDescr = (PUINT8)StringSerial;
                            break;
                        case USB_DESCR_OS_STRING:
                            if(SetupLen > SIZE_STRING_OS)
                                SetupLen = SIZE_STRING_OS;
                            pDescr = (PUINT8)OSStringDescriptor;
                            break;
                        default:
                            len = USB_DESCR_UNSUPPORTED;     //ֵ֧
                            SetupReqCode = INVALID_REQ_CODE; //Ч
                            break;
                    }
                    break;
                default:
                    len = USB_DESCR_UNSUPPORTED; //ֵ֧
                    SetupReqCode = INVALID_REQ_CODE;
                    break;
            }
            len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen; //δ䳤
            memcpy(endp0RTbuff, (UINT8 *)pDescr, len);                           // device  /*ϴ */
            SetupLen -= len;
            pDescr += len;
            break;
        case USB_SET_ADDRESS:
            SetupLen = UsbSetupBuf->wValue.bw.bb1; // ݴUSB豸ַ
            break;
        case 0x31:
            SetupLen = UsbSetupBuf->wValue.bw.bb1; // ݴUSB豸ַ
            break;
        case 0x30:
            break;
        case USB_SET_CONFIGURATION:
            break;
        case USB_GET_STATUS:
            len = 2;
            endp0RTbuff[0] = 0x01;
            endp0RTbuff[1] = 0x00;
            SetupLen = 0;
            break;
        case USB_CLEAR_FEATURE:
            break;
        case USB_SET_FEATURE:
            break;
        case USB_SET_INTERFACE:
            break;
        default:
            len = USB_DESCR_UNSUPPORTED; //stallֵ֧
            SetupReqCode = INVALID_REQ_CODE;
            DUG_PRINTF(" stall \n");
            break;
    }
    return len;
}

/*******************************************************************************
 * @fn      EP0_IN_Callback
 *
 * @brief   USB3.0˵0INص
 *
 * @return   ͳ
 */
UINT16 EP0_IN_Callback(void)
{
    UINT16 len = 0;
    switch(SetupReqCode)
    {
        case USB_GET_DESCRIPTOR:
            len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen;
            memcpy(endp0RTbuff, (UINT8 *)pDescr, len);
            SetupLen -= len;
            pDescr += len;
            break;
    }
    return len;
}

/*******************************************************************************
 * @fn      EP0_OUT_Callback
 *
 * @brief   USB3.0˵0OUTص
 *
 * @return   
 */
UINT16 EP0_OUT_Callback(void)
{
    UINT16 len;
    return len;
}

/*******************************************************************************
 * @fn      USB30_Setup_Status
 *
 * @brief   USB3.0ƴ״̬׶λص
 *
 * @return   None
 */
void USB30_Setup_Status(void)
{
    switch(SetupReqCode)
    {
        case USB_SET_ADDRESS:
            USB30_Device_Setaddress(SetupLen); // SET ADDRESS
            break;
        case 0x31:
            break;
    }
}

/*******************************************************************************
 * @fn      USBSS_IRQHandler
 *
 * @brief   USB3.0 Interrupt Handler.
 *
 * @return   None
 */
void USBSS_IRQHandler(void) //USBSS interrupt service
{
    USB30_IRQHandler();
}

/*******************************************************************************
 * @fn      TMR0_IRQHandler
 *
 * @brief   USB3.0ʧܳʱ
 *
 * @return   None
 */
void TMR0_IRQHandler()
{
    R8_TMR0_INT_FLAG = RB_TMR_IF_CYC_END;

    if(USB30_Link_Status == 1)
    {
        USB30_Link_Status = 0;
        PFIC_DisableIRQ(USBSS_IRQn);
        PFIC_DisableIRQ(LINK_IRQn);
        USB30D_init(DISABLE);
#if 0
        DUG_PRINTF("USB3.0 disable\n");
#endif
        return;
    }
    if(USB30_Link_Status != 3)
    {
        PFIC_DisableIRQ(USBSS_IRQn);
        PFIC_DisableIRQ(LINK_IRQn);
        USB30D_init(DISABLE);
#if 0
        DUG_PRINTF("USB2.0\n");
#endif
        R32_USB_CONTROL = 0;
        PFIC_EnableIRQ(USBHS_IRQn);
        USB20_Device_Init(ENABLE);
    }
    USB30_Link_Status = 1;
    R8_TMR0_INTER_EN = 0;
    PFIC_DisableIRQ(TMR0_IRQn);
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
}

/*******************************************************************************
 * @fn      LINK_IRQHandler
 *
 * @brief   USB3.0 Link Interrupt Handler.
 *
 * @return   None
 */
void LINK_IRQHandler() //USBSS link interrupt service
{
    if(USBSS->LINK_INT_FLAG & LINK_Ux_EXIT_FLAG) // device enter U2
    {
        USBSS->LINK_CFG = CFG_EQ_EN | DEEMPH_CFG | TERM_EN;
        USB30_Switch_Powermode(POWER_MODE_0);
        USBSS->LINK_INT_FLAG = LINK_Ux_EXIT_FLAG;
    }
    if(USBSS->LINK_INT_FLAG & LINK_RDY_FLAG) // POLLING SHAKE DONE
    {
        USBSS->LINK_INT_FLAG = LINK_RDY_FLAG;
        if(USB30_Tx_Lmp_Port) // LMP, TX PORT_CAP & RX PORT_CAP
        {
            USBSS->LMP_TX_DATA0 = LINK_SPEED | PORT_CAP | LMP_HP;
            USBSS->LMP_TX_DATA1 = UP_STREAM | NUM_HP_BUF;
            USBSS->LMP_TX_DATA2 = 0x0;
            USB30_Tx_Lmp_Port = 0;
        }
        //ɹUSB3.0ͨѶ
        USB30_Link_Status = 3;
        PFIC_DisableIRQ(TMR0_IRQn);
        R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
        R8_TMR0_INTER_EN = 0;
        PFIC_DisableIRQ(USBHS_IRQn);
        USB20_Device_Init(DISABLE);
    }

    if(USBSS->LINK_INT_FLAG & LINK_INACT_FLAG)
    {
        USBSS->LINK_INT_FLAG = LINK_INACT_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
    }
    if(USBSS->LINK_INT_FLAG & LINK_DISABLE_FLAG) // GO DISABLED
    {
        USBSS->LINK_INT_FLAG = LINK_DISABLE_FLAG;
        USB30_Link_Status = 1;
        USB30D_init(DISABLE);
        PFIC_DisableIRQ(USBSS_IRQn);
        R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
        R8_TMR0_INTER_EN = 0;
        PFIC_DisableIRQ(TMR0_IRQn);
        PFIC_EnableIRQ(USBHS_IRQn);
        USB20_Device_Init(ENABLE);
    }
    if(USBSS->LINK_INT_FLAG & LINK_RX_DET_FLAG)
    {
        USBSS->LINK_INT_FLAG = LINK_RX_DET_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
    }
    if(USBSS->LINK_INT_FLAG & TERM_PRESENT_FLAG) // term present , begin POLLING
    {
        USBSS->LINK_INT_FLAG = TERM_PRESENT_FLAG;
        if(USBSS->LINK_STATUS & LINK_PRESENT)
        {
            USB30_Switch_Powermode(POWER_MODE_2);
            USBSS->LINK_CTRL |= POLLING_EN;
        }
        else
        {
            USBSS->LINK_INT_CTRL = 0;
            mDelayuS(2000);
            USB30_BUS_RESET();
        }
    }
    if(USBSS->LINK_INT_FLAG & LINK_TXEQ_FLAG) // POLLING SHAKE DONE
    {
        USB30_Tx_Lmp_Port = 1;
        USBSS->LINK_INT_FLAG = LINK_TXEQ_FLAG;
        USB30_Switch_Powermode(POWER_MODE_0);
    }
    if(USBSS->LINK_INT_FLAG & WARM_RESET_FLAG)
    {
        USBSS->LINK_INT_FLAG = WARM_RESET_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
        USB30_BUS_RESET();
        USB30_Device_Setaddress(0);
        USBSS->LINK_CTRL |= TX_WARM_RESET;
        while(USBSS->LINK_STATUS & RX_WARM_RESET)
            ;
        USBSS->LINK_CTRL &= ~TX_WARM_RESET;
        mDelayuS(2);
#if 0
        DUG_PRINTF("warm reset\n");
#endif
    }
    if(USBSS->LINK_INT_FLAG & HOT_RESET_FLAG) //ܻ·hot reset,ע˵
    {
        USBSS->USB_CONTROL |= 1 << 31;
        USBSS->LINK_INT_FLAG = HOT_RESET_FLAG; // HOT RESET begin
        USBSS->UEP0_TX_CTRL = 0;
        USB30_IN_Set(ENDP_1, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_2, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_3, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_4, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_5, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_6, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_7, DISABLE, NRDY, 0, 0);
        USB30_OUT_Set(ENDP_1, NRDY, 0);
        USB30_OUT_Set(ENDP_2, NRDY, 0);
        USB30_OUT_Set(ENDP_3, NRDY, 0);
        USB30_OUT_Set(ENDP_4, NRDY, 0);
        USB30_OUT_Set(ENDP_5, NRDY, 0);
        USB30_OUT_Set(ENDP_6, NRDY, 0);
        USB30_OUT_Set(ENDP_7, NRDY, 0);

        USB30_Device_Setaddress(0);
        USBSS->LINK_CTRL &= ~TX_HOT_RESET; // HOT RESET end
    }
    if(USBSS->LINK_INT_FLAG & LINK_GO_U1_FLAG) // device enter U1
    {
        USB30_Switch_Powermode(POWER_MODE_1);
        USBSS->LINK_INT_FLAG = LINK_GO_U1_FLAG;
    }
    if(USBSS->LINK_INT_FLAG & LINK_GO_U2_FLAG) // device enter U2
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_INT_FLAG = LINK_GO_U2_FLAG;
    }
    if(USBSS->LINK_INT_FLAG & LINK_GO_U3_FLAG) // device enter U2
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_INT_FLAG = LINK_GO_U3_FLAG;
    }
}
/***************Endpointn IN Transaction Processing*******************/

/*******************************************************************************
 * @fn      EP1_IN_Callback
 *
 * @brief   USB3.0 endpoint1 in callback.
 *
 * @return   None
 */
void EP1_IN_Callback(void)
{
    UINT8 nump;
    UINT16V packnum;
    UINT32V offset;
    UINT32V len;


    nump = USB30_IN_Nump(ENDP_1); //nump: ʣͰ
    if( nump == 0 )
    {
        /* лUSB DMAַ */
        HSPI_Rx_Data_DealAddr += ( Endp1_Up_LastPackNum * 1024 );
        if( HSPI_Rx_Data_DealAddr >= DEF_HPSI_RX_DMA_ADDR_MAX )
        {
            HSPI_Rx_Data_DealAddr = DEF_HPSI_DMA_RX_ADDR0;
        }
        USBSS->UEP1_TX_DMA = HSPI_Rx_Data_DealAddr;

        /* ʣδϴ */
        R8_HSPI_INT_EN = 0x00;
        HSPI_Rx_Data_RemainLen -= Endp1_Up_LastPackLen;
        remanlen = HSPI_Rx_Data_RemainLen;
        R8_HSPI_INT_EN = HSPI_Int_En_Save;
    }
    else
    {
        /* лUSB DMAַ */
        HSPI_Rx_Data_DealAddr += ( ( Endp1_Up_LastPackNum - nump ) * 1024 );
        if( HSPI_Rx_Data_DealAddr >= DEF_HPSI_RX_DMA_ADDR_MAX )
        {
            HSPI_Rx_Data_DealAddr = DEF_HPSI_DMA_RX_ADDR0;
        }
        USBSS->UEP1_TX_DMA = HSPI_Rx_Data_DealAddr;

        /* ʣδϴ */
        R8_HSPI_INT_EN = 0x00;
        remanlen = Endp1_Up_LastPackLen - ( nump * 1024 );
        HSPI_Rx_Data_RemainLen -= remanlen;
#if( DEF_FUN_DEBUG_EN == 0x01 )
        /* ԣϴUSB */
        Dbg_USB_Up_TLen += remanlen;
#endif
        remanlen = HSPI_Rx_Data_RemainLen;
        R8_HSPI_INT_EN = HSPI_Int_En_Save;
    }
    /* жǷҪϴ */
    if( remanlen )
    {
        /* 㱾ϴȼ */
        offset = ( DEF_HPSI_RX_DMA_ADDR_MAX - HSPI_Rx_Data_DealAddr );
        if( remanlen >= ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
        {
            /* жϻƫǷ㹻෢͵ĩβ */
            if( offset >= ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
            {
                Endp1_Up_LastPackLen = ( DEF_ENDP1_IN_BURST_LEVEL * 1024 );
                Endp1_Up_LastPackNum = DEF_ENDP1_IN_BURST_LEVEL;
                len = 1024;
            }
            else
            {
                Endp1_Up_LastPackLen = offset;
                Endp1_Up_LastPackNum = Endp1_Up_LastPackLen / 1024;
                len = Endp1_Up_LastPackLen % 1024;
                if( len )
                {
                    Endp1_Up_LastPackNum++;
                }
                else if( len == 0 )
                {
                    len = 1024;
                }
            }
        }
        else
        {
            /* жϻƫǷ㹻෢͵ĩβ */
            if( offset >= remanlen )
            {
                Endp1_Up_LastPackLen = remanlen;
            }
            else
            {
                Endp1_Up_LastPackLen = offset;
            }
            Endp1_Up_LastPackNum = Endp1_Up_LastPackLen / 1024;
            len = Endp1_Up_LastPackLen % 1024;
            if( len )
            {
                Endp1_Up_LastPackNum++;
            }
            else if( len == 0 )
            {
                len = 1024;
            }
        }

        /* USBϴ */
        USB30_IN_ClearIT( ENDP_1 );
        USB30_IN_Set( ENDP_1, ENABLE , ACK , Endp1_Up_LastPackNum, len );
        USB30_Send_ERDY( ENDP_1 | IN , Endp1_Up_LastPackNum );

        /* ö˵1ϴ״̬ */
        Endp1_Up_Status = 0x01;
    }
    else
    {
        /* жǷҪϴ */
        USB30_IN_ClearIT(ENDP_1);

        /* ö˵1ϴ״̬ */
        Endp1_Up_Status = 0x00;
    }
}

/*******************************************************************************
 * @fn      EP2_IN_Callback
 *
 * @brief   USB3.0 endpoint2 in callback.
 *
 * @return   None
 */
void EP2_IN_Callback(void)
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_2); //nump ʣͰ
    DUG_PRINTF("nump:%d\n",nump);
    if(nump == 0)
    {                                                                      //ȫ
        USBSS->UEP2_TX_DMA = (UINT32)(UINT8 *)endp2RTbuff;                 //ͻ DMAַƫ 
        USB30_IN_ClearIT(ENDP_2);                                          //˵״̬ к
        USB30_IN_Set(ENDP_2, ENABLE, ACK, DEF_ENDP2_IN_BURST_LEVEL, 1024); //ö˵ܹ4
        USB30_Send_ERDY(ENDP_2 | IN, DEF_ENDP2_IN_BURST_LEVEL);            //֪ͨȡ4
    }
    else if(nump == 1)
    {
        USB30_IN_ClearIT(ENDP_2);                   //˵״̬ к
        USB30_IN_Set(ENDP_2, ENABLE, ACK, 1, 1024); //ܹ1
        USB30_Send_ERDY(ENDP_2 | IN, 1);
    }
    else if(nump == 2)
    {
        USB30_IN_ClearIT(ENDP_2);                   //˵״̬ к
        USB30_IN_Set(ENDP_2, ENABLE, ACK, 2, 1024); //ܹ2
        USB30_Send_ERDY(ENDP_2 | IN, 2);
    }
    else if(nump == 3)
    {
        USB30_IN_ClearIT(ENDP_2);                   //˵״̬ к
        USB30_IN_Set(ENDP_2, ENABLE, ACK, 3, 1024); //ܹ3
        USB30_Send_ERDY(ENDP_2 | IN, 3);
    }
}

/*******************************************************************************
 * @fn      EP3_IN_Callback
 *
 * @brief   USB3.0 endpoint3 in callback.
 *
 * @return   None
 */
void EP3_IN_Callback(void)
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_3); //nump ʣͰ
    if(nump == 0)
    {
        USBSS->UEP3_TX_DMA = (UINT32)(UINT8 *)endp3RTbuff;        //ͻ DMAַƫ 
        USB30_IN_ClearIT(ENDP_3);                                 //˵״̬ к
        USB30_OUT_Set(ENDP_3, ACK, DEF_ENDP3_OUT_BURST_LEVEL);    //ܹ4
        USB30_Send_ERDY(ENDP_3 | OUT, DEF_ENDP3_OUT_BURST_LEVEL); //֪ͨ4
    }
    else if(nump == 1)
    {
        USB30_IN_ClearIT(ENDP_3);                   //˵״̬ к
        USB30_IN_Set(ENDP_3, ENABLE, ACK, 1, 1024); //ܹ1
        USB30_Send_ERDY(ENDP_3 | IN, 1);
    }
    else if(nump == 2)
    {
        USB30_IN_ClearIT(ENDP_3);                   //˵״̬ к
        USB30_IN_Set(ENDP_3, ENABLE, ACK, 2, 1024); //ܹ2
        USB30_Send_ERDY(ENDP_3 | IN, 2);
    }
    else if(nump == 3)
    {
        USB30_IN_ClearIT(ENDP_3);                   //˵״̬ к
        USB30_IN_Set(ENDP_3, ENABLE, ACK, 3, 1024); //ܹ3
        USB30_Send_ERDY(ENDP_3 | IN, 3);
    }
}

/*******************************************************************************
 * @fn      EP4_IN_Callback
 *
 * @brief   USB3.0 endpoint4 in callback.
 *
 * @return   None
 */
void EP4_IN_Callback(void)
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_4); //s: ʣͰ
    if(nump == 0)
    {                                                             //ȫ
        USBSS->UEP4_TX_DMA = (UINT32)(UINT8 *)endp4RTbuff;        //ͻ DMAַƫ 
        USB30_IN_ClearIT(ENDP_4);                                 //˵״̬ к
        USB30_OUT_Set(ENDP_4, ACK, DEF_ENDP4_OUT_BURST_LEVEL);    //ܹ4
        USB30_Send_ERDY(ENDP_4 | OUT, DEF_ENDP4_OUT_BURST_LEVEL); //֪ͨ4
    }
    else if(nump == 1) //ʣһû
    {
        USB30_IN_ClearIT(ENDP_4);                   //˵״̬ к
        USB30_IN_Set(ENDP_4, ENABLE, ACK, 1, 1024); //ܹ1
        USB30_Send_ERDY(ENDP_4 | IN, 1);
    }
    else if(nump == 2)
    {
        USB30_IN_ClearIT(ENDP_4);                   //˵״̬ к
        USB30_IN_Set(ENDP_4, ENABLE, ACK, 2, 1024); //ܹ2
        USB30_Send_ERDY(ENDP_4 | IN, 2);
    }
    else if(nump == 3)
    {
        USB30_IN_ClearIT(ENDP_4);                   //˵״̬ к
        USB30_IN_Set(ENDP_4, ENABLE, ACK, 3, 1024); //ܹ3
        USB30_Send_ERDY(ENDP_4 | IN, 3);
    }
}
/*******************************************************************************
 * @fn      EP5_IN_Callback
 *
 * @brief   USB3.0 endpoint5 in callback.
 *
 * @return   None
 */
void EP5_IN_Callback(void)
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_5); //nump ʣͰ
    if(nump == 0)
    {                                                             //ȫ
        USBSS->UEP5_TX_DMA = (UINT32)(UINT8 *)endp5RTbuff;        //ͻ DMAַƫ 
        USB30_IN_ClearIT(ENDP_5);                                 //˵״̬ к
        USB30_OUT_Set(ENDP_5, ACK, DEF_ENDP5_OUT_BURST_LEVEL);    //ܹ4
        USB30_Send_ERDY(ENDP_5 | OUT, DEF_ENDP5_OUT_BURST_LEVEL); //֪ͨ4
    }
    else if(nump == 1) //ʣһδ
    {
        USB30_IN_ClearIT(ENDP_5);                   //˵״̬ к
        USB30_IN_Set(ENDP_5, ENABLE, ACK, 1, 1024); //ܹ1
        USB30_Send_ERDY(ENDP_5 | IN, 1);
    }
    else if(nump == 2)
    {
        USB30_IN_ClearIT(ENDP_5);                   //˵״̬ к
        USB30_IN_Set(ENDP_5, ENABLE, ACK, 2, 1024); //ܹ2
        USB30_Send_ERDY(ENDP_5 | IN, 2);
    }
    else if(nump == 3)
    {
        USB30_IN_ClearIT(ENDP_5);                   //˵״̬ к
        USB30_IN_Set(ENDP_5, ENABLE, ACK, 3, 1024); //ܹ3
        USB30_Send_ERDY(ENDP_5 | IN, 3);
    }
}
/*******************************************************************************
 * @fn      EP6_IN_Callback
 *
 * @brief   USB3.0 endpoint6 in callback.
 *
 * @return   None
 */
void EP6_IN_Callback(void)
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_6); //nump ʣͰ
    if(nump == 0)
    {                                                             //ȫ
        USBSS->UEP6_TX_DMA = (UINT32)(UINT8 *)endp6RTbuff;        //ͻ DMAַƫ 
        USB30_IN_ClearIT(ENDP_6);                                 //˵״̬ к
        USB30_OUT_Set(ENDP_6, ACK, DEF_ENDP6_OUT_BURST_LEVEL);    //ܹ4
        USB30_Send_ERDY(ENDP_6 | OUT, DEF_ENDP6_OUT_BURST_LEVEL); //֪ͨ4
    }
    else if(nump == 1) //ʣһû
    {
        USB30_IN_ClearIT(ENDP_6);                   //˵״̬ к
        USB30_IN_Set(ENDP_6, ENABLE, ACK, 1, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_6 | IN, 1);
    }
    else if(nump == 2)
    {
        USB30_IN_ClearIT(ENDP_6);                   //˵״̬ к
        USB30_IN_Set(ENDP_6, ENABLE, ACK, 2, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_6 | IN, 2);
    }
    else if(nump == 3)
    {
        USB30_IN_ClearIT(ENDP_6);                   //˵״̬ к
        USB30_IN_Set(ENDP_6, ENABLE, ACK, 3, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_6 | IN, 3);
    }
}
/*******************************************************************************
 * @fn      EP7_IN_Callback
 *
 * @brief   USB3.0 endpoint7 in callback.
 *
 * @return   None
 */
void EP7_IN_Callback(void)
{
    UINT8 nump;
    nump = USB30_IN_Nump(ENDP_7); //nump:ʣͰ
    if(nump == 0)
    {                                                             //ȫ
        USBSS->UEP7_TX_DMA = (UINT32)(UINT8 *)endp7RTbuff;        //ͻ DMAַƫ 
        USB30_IN_ClearIT(ENDP_7);                                 //˵״̬ к
        USB30_OUT_Set(ENDP_7, ACK, DEF_ENDP7_OUT_BURST_LEVEL);    //ܹ4
        USB30_Send_ERDY(ENDP_7 | OUT, DEF_ENDP7_OUT_BURST_LEVEL); //֪ͨ4
    }
    else if(nump == 1) //ʣһδ
    {
        USB30_IN_ClearIT(ENDP_7);                   //˵״̬ к
        USB30_IN_Set(ENDP_7, ENABLE, ACK, 1, 1024); //ܹ1
        USB30_Send_ERDY(ENDP_7 | IN, 1);
    }
    else if(nump == 2)
    {
        USB30_IN_ClearIT(ENDP_7);                   //˵״̬ к
        USB30_IN_Set(ENDP_7, ENABLE, ACK, 2, 1024); //ܹ2
        USB30_Send_ERDY(ENDP_7 | IN, 2);
    }
    else if(nump == 3)
    {
        USB30_IN_ClearIT(ENDP_7);                   //˵״̬ к
        USB30_IN_Set(ENDP_7, ENABLE, ACK, 3, 1024); //ܹ3
        USB30_Send_ERDY(ENDP_7 | IN, 3);
    }
}
/***************Endpointn OUT Transaction Processing*******************/

/*******************************************************************************
 * @fn      EP1_OUT_Callback
 *
 * @brief   USB3.0 endpoint1 out callback.
 *
 * @return   None
 */
void EP1_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    UINT16V packnum;
    UINT32V offset;
    UINT32V len;

    USB30_OUT_Status(ENDP_1, &nump, &rx_len, &status); //ȡյİ   rxlen Ϊһİ
    /* лַ */
    HSPI_Tx_Data_LoadAddr += ( ( DEF_ENDP1_IN_BURST_LEVEL - nump ) * 1024 );
    if( HSPI_Tx_Data_LoadAddr >= DEF_HPSI_TX_DMA_ADDR_MAX )
    {
        HSPI_Tx_Data_LoadAddr = DEF_HPSI_DMA_TX_ADDR0;
    }
    USBSS->UEP1_RX_DMA = HSPI_Tx_Data_LoadAddr;

    /* 㱾´ */
    R8_HSPI_INT_EN = 0x00;
    if( rx_len == 1024 )   //ͨζݴûн
    {
        remanlen = ( DEF_ENDP1_IN_BURST_LEVEL - nump ) * 1024;
    }
    else        //ַζһ֡ݽ
    {
        remanlen = ( DEF_ENDP1_IN_BURST_LEVEL - 1 - nump ) * 1024;
        remanlen += rx_len;

        /* USB´ͣ־ */
        USB_Down_StopFlag = 0x01;
    }

    HSPI_Tx_Data_RemainLen += remanlen;  //HSPIҪ͵ݳ
//    printf("HSPI_Tx_Data_RemainLen:%dByte\n",HSPI_Tx_Data_RemainLen);


    Dbg_USB_Down_TLen += remanlen;
    remanlen = DEF_ENDP1_RX_BUF_LEN - HSPI_Tx_Data_RemainLen;
    R8_HSPI_INT_EN = HSPI_Int_En_Save;

    /* жǷ㹻´ */
    if( ( remanlen >= 1024 ) && ( USB_Down_StopFlag == 0x00 ) )//û+USBûгַͨUSBк
    {
        /* 㱾´İȼ */
        packnum = DEF_ENDP1_IN_BURST_LEVEL;
        if( remanlen < ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
        {
            packnum = remanlen / 1024;
        }

        /* жϻƫǷ㹻,Ҫ */
        remanlen = ( DEF_HPSI_TX_DMA_ADDR_MAX - HSPI_Tx_Data_LoadAddr );
        if( remanlen < ( DEF_ENDP1_IN_BURST_LEVEL * 1024 ) )
        {
            packnum = remanlen / 1024;
        }

        /* ֪ͨ´N */
        USB30_OUT_ClearIT( ENDP_1 );
        USB30_OUT_Set( ENDP_1, ACK, packnum );
        USB30_Send_ERDY( ENDP_1 | OUT , packnum );

         /* ö˵1´״̬ */
        Endp1_Down_Status = 0x00;
    }
    else    //з
    {
        /* ֪ͨͣ´ */
        USB30_OUT_ClearIT( ENDP_1 );
        USB30_OUT_Set( ENDP_1, NRDY, 0 );
        packnum = 0;

        /* ö˵1´״̬ */
        Endp1_Down_Status = 0x01;
    }

    /* ˢ¼´ʱʱ */
    Endp1_Down_IdleCount = 0x00;
}

/*******************************************************************************
 * @fn      EP2_OUT_Callback
 *
 * @brief   USB3.0 endpoint2 out callback.
 *
 * @return   None
 */
void EP2_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    UINT32 recv_index;
    USB30_OUT_Status(ENDP_2, &nump, &rx_len, &status); //ȡյİ
    if(nump == 0)                                      //ȫ
    {
        USB30_OUT_ClearIT(ENDP_2);                                //˵״̬ 
        USBSS->UEP2_RX_DMA = (UINT32)(UINT8 *)endp2RTbuff;        //ͻģʽڵַԶƫ ַ
        USB30_OUT_Set(ENDP_2, ACK, DEF_ENDP2_OUT_BURST_LEVEL);    //ö˵ܹ4
        USB30_Send_ERDY(ENDP_2 | OUT, DEF_ENDP2_OUT_BURST_LEVEL); //֪ͨ·4
    }
    else if(nump == 1)
    {
        USB30_OUT_ClearIT(ENDP_2);
        USB30_OUT_Set(ENDP_2, ACK, 1);    //ܹһ
        USB30_Send_ERDY(ENDP_2 | OUT, 1); //֪ͨ·һ
    }
    else if(nump == 2)
    {
        USB30_OUT_ClearIT(ENDP_2);
        USB30_OUT_Set(ENDP_2, ACK, 2);    //ܹ2
        USB30_Send_ERDY(ENDP_2 | OUT, 2); //֪ͨ·2
    }
    else if(nump == 3)
    {
        USB30_OUT_ClearIT(ENDP_2);
        USB30_OUT_Set(ENDP_2, ACK, 3);    //ܹ3
        USB30_Send_ERDY(ENDP_2 | OUT, 3); //֪ͨ·3
    }
}
/*******************************************************************************
 * @fn      EP3_OUT_Callback
 *
 * @brief   USB3.0 endpoint3 out callback.
 *
 * @return   None
 */
void EP3_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    USB30_OUT_Status(ENDP_3, &nump, &rx_len, &status); //ȡյİ
    if(nump == 0)
    {
        USB30_OUT_ClearIT(ENDP_3);                                         //˵״̬ 
        USBSS->UEP3_RX_DMA = (UINT32)(UINT8 *)endp3RTbuff;                 //ͻģʽڵַԶƫ ַ
        USB30_IN_Set(ENDP_3, ENABLE, ACK, DEF_ENDP3_IN_BURST_LEVEL, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_3 | IN, DEF_ENDP3_IN_BURST_LEVEL);            //֪ͨȡ4
    }
    else if(nump == 1)
    {
        USB30_OUT_ClearIT(ENDP_3);
        USB30_OUT_Set(ENDP_3, ACK, 1);    //ܹһ
        USB30_Send_ERDY(ENDP_3 | OUT, 1); //֪ͨ·һ
    }
    else if(nump == 2)
    {
        USB30_OUT_ClearIT(ENDP_3);
        USB30_OUT_Set(ENDP_3, ACK, 2);    //ܹһ
        USB30_Send_ERDY(ENDP_3 | OUT, 2); //֪ͨ·һ
    }
    else if(nump == 3)
    {
        USB30_OUT_ClearIT(ENDP_3);
        USB30_OUT_Set(ENDP_3, ACK, 3);    //ܹһ
        USB30_Send_ERDY(ENDP_3 | OUT, 3); //֪ͨ·һ
    }
}
/*******************************************************************************
 * @fn      EP4_OUT_Callback
 *
 * @brief   USB3.0 endpoint4 out callback.
 *
 * @return   None
 */
void EP4_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    USB30_OUT_Status(ENDP_4, &nump, &rx_len, &status); //ȡյİ
    if(nump == 0)
    {
        USB30_OUT_ClearIT(ENDP_4);                                         //˵״̬ 
        USBSS->UEP4_RX_DMA = (UINT32)(UINT8 *)endp4RTbuff;                 //ͻģʽڵַԶƫ ַ
        USB30_IN_Set(ENDP_4, ENABLE, ACK, DEF_ENDP4_IN_BURST_LEVEL, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_4 | IN, DEF_ENDP4_IN_BURST_LEVEL);
    }
    else if(nump == 1)
    {
        USB30_OUT_ClearIT(ENDP_4);
        USB30_OUT_Set(ENDP_4, ACK, 1);    //ܹһ
        USB30_Send_ERDY(ENDP_4 | OUT, 1); //֪ͨ·һ
    }
    else if(nump == 2)
    {
        USB30_OUT_ClearIT(ENDP_4);
        USB30_OUT_Set(ENDP_4, ACK, 2);    //ܹ2
        USB30_Send_ERDY(ENDP_4 | OUT, 2); //֪ͨ·2
    }
    else if(nump == 3)
    {
        USB30_OUT_ClearIT(ENDP_4);
        USB30_OUT_Set(ENDP_4, ACK, 3);    //ܹ3
        USB30_Send_ERDY(ENDP_4 | OUT, 3); //֪ͨ·3
    }
}
/*******************************************************************************
 * @fn      EP5_OUT_Callback
 *
 * @brief   USB3.0 endpoint5 out callback.
 *
 * @return   None
 */
void EP5_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    USB30_OUT_Status(ENDP_5, &nump, &rx_len, &status); //ȡյİ
    if(nump == 0)
    {
        USB30_OUT_ClearIT(ENDP_5);                                         //˵״̬ 
        USBSS->UEP5_RX_DMA = (UINT32)(UINT8 *)endp5RTbuff;                 //ͻģʽڵַԶƫ ַ
        USB30_IN_Set(ENDP_5, ENABLE, ACK, DEF_ENDP5_IN_BURST_LEVEL, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_5 | IN, DEF_ENDP5_IN_BURST_LEVEL);
    }
    else if(nump == 1)
    {
        USB30_OUT_ClearIT(ENDP_5);
        USB30_OUT_Set(ENDP_5, ACK, 1);    //ܹһ
        USB30_Send_ERDY(ENDP_5 | OUT, 1); //֪ͨ·һ
    }
    else if(nump == 2)
    {
        USB30_OUT_ClearIT(ENDP_5);
        USB30_OUT_Set(ENDP_5, ACK, 2);    //ܹһ
        USB30_Send_ERDY(ENDP_5 | OUT, 2); //֪ͨ·һ
    }
    else if(nump == 3)
    {
        USB30_OUT_ClearIT(ENDP_5);
        USB30_OUT_Set(ENDP_5, ACK, 3);    //ܹһ
        USB30_Send_ERDY(ENDP_5 | OUT, 3); //֪ͨ·һ
    }
}
/*******************************************************************************
 * @fn      EP6_OUT_Callback
 *
 * @brief   USB3.0 endpoint6 out callback.
 *
 * @return   None
 */
void EP6_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    USB30_OUT_Status(ENDP_6, &nump, &rx_len, &status); //ȡյİ
    if(nump == 0)
    {
        USB30_OUT_ClearIT(ENDP_6);                                         //˵״̬ 
        USBSS->UEP6_RX_DMA = (UINT32)(UINT8 *)endp6RTbuff;                 //ͻģʽڵַԶƫ ַ
        USB30_IN_Set(ENDP_6, ENABLE, ACK, DEF_ENDP6_IN_BURST_LEVEL, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_6 | IN, DEF_ENDP6_IN_BURST_LEVEL);
    }
    else if(nump == 1)
    {
        USB30_OUT_ClearIT(ENDP_6);
        USB30_OUT_Set(ENDP_6, ACK, 1);    //ܹһ
        USB30_Send_ERDY(ENDP_6 | OUT, 1); //֪ͨ·һ
    }
    else if(nump == 2)
    {
        USB30_OUT_ClearIT(ENDP_6);
        USB30_OUT_Set(ENDP_6, ACK, 2);    //ܹ2
        USB30_Send_ERDY(ENDP_6 | OUT, 2); //֪ͨ·2
    }
    else if(nump == 3)
    {
        USB30_OUT_ClearIT(ENDP_6);
        USB30_OUT_Set(ENDP_6, ACK, 3);    //ܹ3
        USB30_Send_ERDY(ENDP_6 | OUT, 3); //֪ͨ·3
    }
}
/*******************************************************************************
 * @fn      EP7_OUT_Callback
 *
 * @brief   USB3.0 endpoint7 out callback.
 *
 * @return   None
 */
void EP7_OUT_Callback(void)
{
    UINT16 rx_len, i;
    UINT8  nump;
    UINT8  status;
    USB30_OUT_Status(ENDP_7, &nump, &rx_len, &status); //ȡյİ
    if(nump == 0)
    {
        USB30_OUT_ClearIT(ENDP_7);                                         //˵״̬ 
        USBSS->UEP7_RX_DMA = (UINT32)(UINT8 *)endp7RTbuff;                 //ͻģʽڵַԶƫ ַ
        USB30_IN_Set(ENDP_7, ENABLE, ACK, DEF_ENDP7_IN_BURST_LEVEL, 1024); //ܹ4
        USB30_Send_ERDY(ENDP_7 | IN, DEF_ENDP7_IN_BURST_LEVEL);
    }
    else if(nump == 1)
    {
        USB30_OUT_ClearIT(ENDP_7);
        USB30_OUT_Set(ENDP_7, ACK, 1);    //ܹһ
        USB30_Send_ERDY(ENDP_7 | OUT, 1); //֪ͨ·һ
    }
    else if(nump == 2)
    {
        USB30_OUT_ClearIT(ENDP_7);
        USB30_OUT_Set(ENDP_7, ACK, 2);    //ܹ2
        USB30_Send_ERDY(ENDP_7 | OUT, 2); //֪ͨ·2
    }
    else if(nump == 3)
    {
        USB30_OUT_ClearIT(ENDP_7);
        USB30_OUT_Set(ENDP_7, ACK, 3);    //ܹ3
        USB30_Send_ERDY(ENDP_7 | OUT, 3); //֪ͨ·3
    }
}

/*******************************************************************************
 * @fn      USB30_ITP_Callback
 *
 * @brief   USB3.0 ITPص
 *
 * @return   None
 */
void USB30_ITP_Callback(UINT32 ITPCounter)
{
}
